﻿
'______________________________________________

'         A D O    R O U T I N E S   F O R   A C C E S S
'                  Originally Created 8/11/2010
'______________________________________________

'This class holds some common methods I can use to manage my ADO objects. The members are defined as public so
'you can access them from any class.  The members are both public & private. To use this class you must instantiate an object.

'Be careful not to confuse Conn (connection object) with the connString

'Updated 9/1/2010
'   9/1/2010 Made the class much more generic. They can pass a SQL Select and Conn String, name of the grid to fill, and a table name.
'                   All the work is done here and the grid is filled by a method in this class.



Option Explicit On

'---import the usual suspects
Imports System.Data
Imports System.Data.OleDb
Imports System.Windows.Forms

Public Class ADORoutines

#Region "Properties"

    '---the connection string which defines the type and location of the DB
    Private _connString As String = ""
    Public Property connString() As String
        Get
            Return _connString
        End Get

        Set(ByVal value As String)
            _connString = value
        End Set
    End Property

    '---the SQL select string...what records do we want?
    Private _sqlSelect As String = ""
    Public Property SQL_SELECT() As String
        Get
            Return _sqlSelect
        End Get
        Set(ByVal value As String)
            _sqlSelect = value
        End Set
    End Property

#End Region

#Region "Fill the DataGridView Control"

    '---when this is called, we pass it the name of the grid and the name of the table to hold data in dataset. It returns a Boolean to
    '       show if it worked or not. It has self-contained error handler.

    Public Function FillDA(ByVal gridName As DataGridView, ByVal myTableName As String) As Boolean
        Dim customersDS As New DataSet
        Dim Conn As New OleDbConnection(_connString)    'from our property they set in their form
        Dim dataAdapter As New OleDbDataAdapter(_sqlSelect, Conn)    'create the data adapter here

        Try
            dataAdapter.Fill(customersDS, myTableName)                  'now fill it
            gridName.DataSource = customersDS                              'tell Mr. Grid where to bind
            gridName.DataMember = myTableName                           'which table?

            Return True                                                                     'success
        Catch ex As Exception
            MessageBox.Show("An error occurred while reading the database." & ex.Message,
                            "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False                                                                    'frown
        End Try

    End Function
#End Region

End Class
